'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _mapValues2 = require('lodash/mapValues');

var _mapValues3 = _interopRequireDefault(_mapValues2);

var _chain2 = require('lodash/chain');

var _chain3 = _interopRequireDefault(_chain2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Bar = function (_React$Component) {
  _inherits(Bar, _React$Component);

  function Bar() {
    _classCallCheck(this, Bar);

    return _possibleConstructorReturn(this, (Bar.__proto__ || Object.getPrototypeOf(Bar)).apply(this, arguments));
  }

  _createClass(Bar, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var bars = [];
      var limit = 5;
      var _props$data = this.props.data,
          c = _props$data.c,
          name = _props$data.name,
          key = _props$data.key,
          stack = _props$data.stack;


      if (this.props.group) {
        var highlights = (0, _chain3.default)(stack).sortBy('c').reverse().slice(0, limit).map('key').value();
        var amount = c;
        (0, _mapValues3.default)(stack, function (bar) {
          if (highlights.includes(bar.key)) {
            amount -= bar.c;
            var proportion = _this2.props.max > 0 ? bar.c / _this2.props.max : 0;
            var width = proportion * 100 + '%';
            bars.push(_react2.default.createElement('div', {
              key: bar.key + _this2.props.group,
              title: bar.name + ': ' + (0, _utils.numberFormat)(bar.c) + ' (' + (bar.c / c * 100).toFixed(3) + '%)',
              className: 'bar-graph__bar',
              style: {
                width: width,
                backgroundColor: _this2.props.getColor(bar.key, _this2.props.group)
              }
            }));
          }
        });

        if (amount > 0) {
          var percentage = this.props.max > 0 ? amount / this.props.max * 100 : 0;
          var width = percentage + '%';
          bars.push(_react2.default.createElement('div', {
            title: 'others: ' + (0, _utils.numberFormat)(amount) + ', (' + (amount / c * 100).toFixed(3) + '%)',
            key: 'others' + this.props.group,
            className: 'bar-graph__bar',
            style: {
              width: width,
              backgroundColor: this.props.getColor('other')
            }
          }));
        }
      } else {
        var _percentage = this.props.max > 0 ? c / this.props.max * 100 : 0;
        var _width = _percentage + '%';
        bars.push(_react2.default.createElement('div', {
          title: name + ': ' + (0, _utils.numberFormat)(c),
          key: key,
          className: 'bar-graph__bar',
          style: { width: _width, backgroundColor: this.props.getColor(key) }
        }));
      }

      return _react2.default.createElement(
        'div',
        { className: 'bar-graph__bar-wrap' },
        bars,
        _react2.default.createElement(
          'span',
          { className: 'bar-graph__bar__percentage' },
          (this.props.proportion * 100).toFixed(3) + '%'
        )
      );
    }
  }]);

  return Bar;
}(_react2.default.Component);

Bar.propTypes = {
  data: _propTypes2.default.object,
  max: _propTypes2.default.number,
  group: _propTypes2.default.string,
  getColor: _propTypes2.default.func,
  name: _propTypes2.default.string,
  proportion: _propTypes2.default.number
};
exports.default = Bar;