'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _map2 = require('lodash/map');

var _map3 = _interopRequireDefault(_map2);

var _mapValues2 = require('lodash/mapValues');

var _mapValues3 = _interopRequireDefault(_mapValues2);

var _size2 = require('lodash/size');

var _size3 = _interopRequireDefault(_size2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactBootstrap = require('react-bootstrap');

var _utils = require('../utils');

var _bar_graph_header = require('./bar_graph_header');

var _bar_graph_header2 = _interopRequireDefault(_bar_graph_header);

var _bar_list = require('./bar_list');

var _bar_list2 = _interopRequireDefault(_bar_list);

require('./style/BarGraph.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// TODO remove lodash


var BarGraph = function (_React$Component) {
  _inherits(BarGraph, _React$Component);

  function BarGraph() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, BarGraph);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = BarGraph.__proto__ || Object.getPrototypeOf(BarGraph)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      stretched: false,
      search: null
    }, _this.onSearch = function (e) {
      var search = e.target.value;

      if (search.length) {
        try {
          new RegExp(search, 'i');
          _this.setState({
            search: search
          });
        } catch (e) {
          _this.setState({
            search: false
          });
        }
      } else {
        _this.setState({
          search: null
        });
      }
    }, _this.onStretch = function () {
      _this.setState({
        stretched: !_this.state.stretched
      });
    }, _this.onChange = function (name, selected) {
      return _this.props.onChange && _this.props.onChange(name, selected);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(BarGraph, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var dimension = (0, _utils.normalizeData)(this.props.data, this.props.lookup[this.props.name], this.props.lookup[this.props.group]);
      var allData = (0, _mapValues3.default)(this.props.allData, function (data, name) {
        return (0, _utils.normalizeData)(data, _this2.props.lookup[name], _this2.props.lookup[_this2.props.group]);
      });
      var comparing = this.props.comparingTo ? (0, _utils.normalizeData)(this.props.comparingTo, this.props.lookup[this.props.name], this.props.lookup[this.props.group]) : null;
      var filter = this.state.search;
      var isGroupSource = this.props.group && this.props.group === this.props.name;

      return _react2.default.createElement(
        _reactBootstrap.Panel,
        { bsStyle: isGroupSource ? 'info' : 'default', className: 'bar-graph__container' },
        _react2.default.createElement(
          _reactBootstrap.Panel.Heading,
          null,
          _react2.default.createElement(_bar_graph_header2.default, {
            name: this.props.name,
            description: this.props.description,
            dimensions: (0, _map3.default)(dimension.serie, 'key'),
            total: dimension.total,
            comparingTo: comparing && comparing.serie,
            dimension: dimension.serie,
            selectedItems: this.props.selected,
            onSearch: this.onSearch,
            filter: filter,
            size: (0, _size3.default)(dimension.serie),
            onStretch: !isGroupSource && this.onStretch,
            stretched: !isGroupSource && this.state.stretched,
            onChange: this.onChange,
            slice: this.props.slice,
            group: this.props.group,
            allData: allData
          })
        ),
        _react2.default.createElement(
          _reactBootstrap.Panel.Body,
          null,
          filter ? _react2.default.createElement(
            'div',
            { className: 'bar-graph__search-help' },
            'Search result for "',
            filter,
            '"'
          ) : null,
          _react2.default.createElement(_bar_list2.default, {
            name: this.props.name,
            dimension: dimension,
            filter: filter,
            comparingTo: comparing,
            group: this.props.group,
            stretched: this.state.stretched,
            lookup: this.props.lookup,
            selected: this.props.selected,
            onChange: this.onChange,
            slice: this.props.slice,
            getColor: this.props.getColor
          })
        )
      );
    }
  }]);

  return BarGraph;
}(_react2.default.Component);

BarGraph.propTypes = {
  comparingTo: _propTypes2.default.object,
  data: _propTypes2.default.object,
  getColor: _propTypes2.default.func,
  group: _propTypes2.default.string,
  lookup: _propTypes2.default.object,
  name: _propTypes2.default.string.isRequired,
  description: _propTypes2.default.string,
  onChange: _propTypes2.default.func,
  selected: _propTypes2.default.array
};
BarGraph.defaultProps = {
  name: '',
  group: null,
  selected: [],
  comparingTo: null,
  lookup: {}
};
exports.default = BarGraph;