'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BarGraphHeader = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _each2 = require('lodash/each');

var _each3 = _interopRequireDefault(_each2);

var _map2 = require('lodash/map');

var _map3 = _interopRequireDefault(_map2);

var _difference2 = require('lodash/difference');

var _difference3 = _interopRequireDefault(_difference2);

var _size2 = require('lodash/size');

var _size3 = _interopRequireDefault(_size2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactBootstrap = require('react-bootstrap');

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// TODO remove lodash


var BarGraphHeader = exports.BarGraphHeader = function (_React$Component) {
  _inherits(BarGraphHeader, _React$Component);

  function BarGraphHeader() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, BarGraphHeader);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = BarGraphHeader.__proto__ || Object.getPrototypeOf(BarGraphHeader)).call.apply(_ref, [this].concat(args))), _this), _this.onDownload = function (dataLabel, volume, dataSerie, comparingTo) {
      return function () {
        var defaultDimension = { c: 0 };
        var stacksLabel = '';
        var delimiter = ',';
        var endLine = '\r\n';

        var createLine = function createLine(name) {
          var count = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
          var stack = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];

          var proportion = volume > 0 && count > 0 ? (count || 0) / volume : 0;
          var stacks = '';

          if (_this.props.group) {
            (0, _each3.default)(_this.props.allData[_this.props.group].serie, function (d, i) {
              stacks += '' + delimiter + (stack[i] || defaultDimension).c;
            });
          }

          stacks += '' + delimiter + count;

          return '' + name + delimiter + (proportion * 100).toFixed(3) + '%' + stacks + endLine;
        };

        var body = (0, _map3.default)(dataSerie, function (el) {
          if (comparingTo) {
            var window = comparingTo[el.key] || { count: 0, stack: [] };
            return '' + createLine('' + el.name + delimiter + 'A', window.c, window.stack) + createLine('' + el.name + delimiter + 'B', el.c, el.stack);
          } else {
            return createLine(el.name, el.c, el.stack);
          }
        }).join('');

        if (_this.props.group) {
          (0, _each3.default)(_this.props.allData[_this.props.group].serie, function (d, i) {
            stacksLabel += '' + delimiter + (d.name || i);
          });
        }

        stacksLabel += delimiter + 'event count';

        var header = '' + dataLabel + delimiter + (comparingTo ? 'window' + delimiter : '') + 'percentage' + stacksLabel + endLine;
        var fileData = header + body;

        var blob = new Blob([fileData], { type: 'text/plain' });

        (0, _utils.saveData)('event_' + _this.props.name + '_serie_' + dataLabel + (_this.props.group ? '_grouped_by_' + _this.props.group : '') + '.csv', blob);
      };
    }, _this.onClickAddAll = function (e) {
      e.preventDefault();
      _this.props.onChange(_this.props.name, (0, _difference3.default)(_this.props.dimensions, _this.props.selectedItems));
    }, _this.onClickInvert = function (e) {
      e.preventDefault();
      _this.props.onChange(_this.props.name, _this.props.dimensions);
    }, _this.onClickRemoveAll = function (e) {
      e.preventDefault();
      _this.props.onChange(_this.props.name, _this.props.selectedItems);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(BarGraphHeader, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var name = this.props.description ? _react2.default.createElement(
        _reactBootstrap.OverlayTrigger,
        { placement: 'top', overlay: _react2.default.createElement(
            _reactBootstrap.Tooltip,
            { id: this.props.name },
            this.props.description
          ) },
        _react2.default.createElement(
          'span',
          null,
          this.props.name
        )
      ) : this.props.name;

      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          'h4',
          null,
          name,
          ' ',
          _react2.default.createElement(
            'small',
            null,
            '(',
            (this.props.slice && this.props.slice < this.props.size ? this.props.slice + ' of ' : '') + this.props.size,
            ')'
          )
        ),
        _react2.default.createElement(
          _reactBootstrap.ButtonGroup,
          { className: 'bar-graph__actions' },
          _react2.default.createElement(
            _reactBootstrap.Button,
            {
              title: 'Click to save as csv',
              onClick: this.onDownload(this.props.name, this.props.total, this.props.dimension, this.props.comparingTo)
            },
            _react2.default.createElement(_reactBootstrap.Glyphicon, { glyph: 'save' })
          ),
          _react2.default.createElement(
            _react2.default.Fragment,
            null,
            _react2.default.createElement(
              _reactBootstrap.OverlayTrigger,
              {
                trigger: 'click',
                rootClose: true,
                placement: 'bottom',
                overlay: _react2.default.createElement(
                  _reactBootstrap.Popover,
                  { className: 'bar-graph__filter__dimension', id: 'popover-' + this.props.name, title: '' },
                  _react2.default.createElement(
                    'div',
                    null,
                    _react2.default.createElement(
                      _reactBootstrap.ButtonGroup,
                      null,
                      _react2.default.createElement(
                        _reactBootstrap.Button,
                        { bsSize: 'small', bsStyle: 'primary', onClick: this.onClickAddAll },
                        'Add all'
                      ),
                      _react2.default.createElement(
                        _reactBootstrap.Button,
                        {
                          bsSize: 'small',
                          bsStyle: 'primary',
                          onClick: this.onClickInvert,
                          disabled: !(0, _size3.default)(this.props.selectedItems)
                        },
                        'Invert selected'
                      ),
                      _react2.default.createElement(
                        _reactBootstrap.Button,
                        {
                          bsSize: 'small',
                          bsStyle: 'primary',
                          onClick: this.onClickRemoveAll,
                          disabled: !(0, _size3.default)(this.props.selectedItems)
                        },
                        'Remove all'
                      )
                    )
                  ),
                  _react2.default.createElement('br', null),
                  _react2.default.createElement(
                    'div',
                    null,
                    _react2.default.createElement(
                      _reactBootstrap.FormGroup,
                      {
                        className: 'bar-graph__list__search',
                        bsSize: 'small',
                        validationState: this.props.filter === false ? 'error' : this.props.filter ? 'success' : null
                      },
                      _react2.default.createElement(_reactBootstrap.FormControl, {
                        defaultValue: this.props.filter ? this.props.filter : undefined,
                        onChange: this.props.onSearch,
                        placeholder: 'Looking for...',
                        type: 'text'
                      }),
                      _react2.default.createElement(
                        _reactBootstrap.FormControl.Feedback,
                        null,
                        _react2.default.createElement(_reactBootstrap.Glyphicon, { glyph: 'search' })
                      )
                    )
                  ),
                  _react2.default.createElement('br', null),
                  _react2.default.createElement(
                    'div',
                    null,
                    _react2.default.createElement(
                      _reactBootstrap.ButtonToolbar,
                      null,
                      (0, _map3.default)(this.props.selectedItems, function (f) {
                        return _react2.default.createElement(
                          _reactBootstrap.Button,
                          {
                            className: 'bar-graph__filter__dimension__button',
                            key: 'filter-' + f,
                            onClick: function onClick() {
                              _this2.props.onChange(_this2.props.name, f);
                            },
                            bsSize: 'xsmall'
                          },
                          f,
                          ' ',
                          _react2.default.createElement(_reactBootstrap.Glyphicon, { glyph: 'remove-sign' })
                        );
                      })
                    )
                  ),
                  ' '
                )
              },
              _react2.default.createElement(
                _reactBootstrap.Button,
                {
                  title: 'Click to change the applied filters',
                  bsStyle: (this.props.selectedItems || this.props.filter || []).length ? 'info' : 'default'
                },
                _react2.default.createElement(_reactBootstrap.Glyphicon, { glyph: 'filter' })
              )
            )
          ),
          this.props.onStretch ? _react2.default.createElement(
            _reactBootstrap.Button,
            {
              title: 'Click to change the view mode',
              bsStyle: this.props.stretched ? 'primary' : 'default',
              onClick: this.props.onStretch
            },
            _react2.default.createElement(_reactBootstrap.Glyphicon, { glyph: 'tasks' })
          ) : null,
          _react2.default.createElement(
            _reactBootstrap.Button,
            {
              title: 'Click to change the stacking based in this group',
              bsStyle: this.props.group === this.props.name ? 'primary' : 'default',
              onClick: function onClick() {
                _this2.props.onChange('group', _this2.props.name);
              }
            },
            _react2.default.createElement(_reactBootstrap.Glyphicon, { glyph: 'indent-left' })
          )
        )
      );
    }
  }]);

  return BarGraphHeader;
}(_react2.default.Component);

BarGraphHeader.propTypes = {
  allData: _propTypes2.default.object,
  comparingTo: _propTypes2.default.object,
  dimension: _propTypes2.default.object,
  dimensions: _propTypes2.default.array,
  selectedItems: _propTypes2.default.array,
  filter: _propTypes2.default.string,
  group: _propTypes2.default.string,
  name: _propTypes2.default.string.isRequired,
  description: _propTypes2.default.string,
  size: _propTypes2.default.number,
  slice: _propTypes2.default.number,
  total: _propTypes2.default.number,
  stretched: _propTypes2.default.bool,
  onChange: _propTypes2.default.func,
  onSearch: _propTypes2.default.func,
  onStretch: _propTypes2.default.func
};