'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require('../utils');

var _bar = require('./bar');

var _bar2 = _interopRequireDefault(_bar);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BarLine = function (_React$Component) {
  _inherits(BarLine, _React$Component);

  function BarLine() {
    _classCallCheck(this, BarLine);

    return _possibleConstructorReturn(this, (BarLine.__proto__ || Object.getPrototypeOf(BarLine)).apply(this, arguments));
  }

  _createClass(BarLine, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate() {
      return true;
    }
  }, {
    key: 'getIcon',
    value: function getIcon(val1, val2) {
      var percentage = (Math.abs(1 - val1 / val2) * 100).toFixed(1);
      if (val1 > val2) {
        return _react2.default.createElement(
          'div',
          { className: 'bar-graph__variation__wrapper' },
          _react2.default.createElement(
            'span',
            { className: 'bar-graph__variation--up' },
            '▲',
            isFinite(percentage) ? _react2.default.createElement(
              'span',
              { className: 'variation__icon' },
              percentage + '% '
            ) : _react2.default.createElement(
              'span',
              { className: 'variation__icon--infinity' },
              '\u221E'
            )
          )
        );
      } else if (val2 > val1) {
        return _react2.default.createElement(
          'div',
          { className: 'bar-graph__variation__wrapper' },
          _react2.default.createElement(
            'span',
            { className: 'bar-graph__variation--down' },
            '▼',
            isFinite(percentage) ? _react2.default.createElement(
              'span',
              { className: 'variation__icon' },
              percentage + '% '
            ) : _react2.default.createElement(
              'span',
              { className: 'variation__icon--infinity' },
              '\u221E'
            )
          )
        );
      }

      return _react2.default.createElement(
        'div',
        { className: 'bar-graph__variation__wrapper' },
        _react2.default.createElement(
          'span',
          { className: 'bar-graph__variation' },
          '='
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      return _react2.default.createElement(
        'div',
        {
          className: 'bar-graph' + (this.props.selected ? ' selected' : ''),
          onClick: function onClick() {
            return _this2.props.onChange(_this2.props.name, _this2.props.data.key);
          }
        },
        this.props.comparingData ? this.getIcon(this.props.data.c, this.props.comparingData.c) : null,
        _react2.default.createElement(
          'div',
          { className: 'bar-graph__label__wrapper' },
          _react2.default.createElement(
            'div',
            { className: 'bar-graph__label' },
            this.props.label
          )
        ),
        this.props.comparingData ? _react2.default.createElement(
          'div',
          { className: 'bar-graph__value__wrapper' },
          _react2.default.createElement(
            'div',
            { className: 'bar-graph__value' },
            (0, _utils.numberFormat)(this.props.comparingData.c || 0)
          ),
          _react2.default.createElement(
            'div',
            { className: 'bar-graph__value' },
            (0, _utils.numberFormat)(this.props.data.c || 0)
          )
        ) : _react2.default.createElement(
          'div',
          { className: 'bar-graph__value__wrapper' },
          _react2.default.createElement(
            'div',
            { className: 'bar-graph__value' },
            (0, _utils.numberFormat)(this.props.data.c || 0)
          )
        ),
        _react2.default.createElement(
          'div',
          { className: 'bar-graph__bar-container__wrapper' },
          _react2.default.createElement(
            'div',
            { className: 'bar-graph__bar-container' },
            this.props.comparingData ? _react2.default.createElement(_bar2.default, {
              key: 'comparing',
              container: this.props.container,
              data: this.props.comparingData,
              group: this.props.group,
              name: this.props.name,
              max: this.props.stretched ? this.props.comparingData.c : this.props.max,
              getColor: this.props.getColor,
              proportion: this.props.comparingTotal > 0 && this.props.comparingData.c > 0 ? (this.props.comparingData.c || 0) / this.props.comparingTotal : 0
            }) : null,
            _react2.default.createElement(_bar2.default, {
              container: this.props.container,
              data: this.props.data,
              group: this.props.group,
              name: this.props.name,
              max: this.props.stretched ? this.props.data.c : this.props.max,
              getColor: this.props.getColor,
              proportion: this.props.total > 0 && this.props.data.c > 0 ? (this.props.data.c || 0) / this.props.total : 0
            })
          )
        )
      );
    }
  }]);

  return BarLine;
}(_react2.default.Component);

BarLine.propTypes = {
  onChange: _propTypes2.default.func,
  container: _propTypes2.default.any,
  data: _propTypes2.default.object,
  getColor: _propTypes2.default.func,
  group: _propTypes2.default.string,
  label: _propTypes2.default.string,
  max: _propTypes2.default.number,
  selected: _propTypes2.default.bool,
  name: _propTypes2.default.any,
  stretched: _propTypes2.default.bool,
  total: _propTypes2.default.number,
  comparingData: _propTypes2.default.any,
  comparingTotal: _propTypes2.default.number
};
exports.default = BarLine;