'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _isEmpty2 = require('lodash/isEmpty');

var _isEmpty3 = _interopRequireDefault(_isEmpty2);

var _map2 = require('lodash/map');

var _map3 = _interopRequireDefault(_map2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _d = require('d3');

var _d3Scale = require('d3-scale');

var _utils = require('../utils');

var _bar_line = require('./bar_line');

var _bar_line2 = _interopRequireDefault(_bar_line);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// TODO remove lodash


var BarList = function (_React$Component) {
  _inherits(BarList, _React$Component);

  function BarList() {
    _classCallCheck(this, BarList);

    return _possibleConstructorReturn(this, (BarList.__proto__ || Object.getPrototypeOf(BarList)).apply(this, arguments));
  }

  _createClass(BarList, [{
    key: 'render',


    // shouldComponentUpdate(){
    //   return true;
    // }

    value: function render() {
      var _this2 = this;

      var _props$dimension = this.props.dimension,
          serie = _props$dimension.serie,
          max = _props$dimension.max,
          total = _props$dimension.total;

      if (!(0, _isEmpty3.default)(serie)) {
        var comparingMax = this.props.comparingTo ? this.props.comparingTo.max : 0;
        var prefix = this.props.hideCommonPrefix ? (0, _utils.getCommonPrefix)((0, _map3.default)(this.props.data, function (d) {
          if (d.name !== '<not defined>') return d.name;
        })) : '';

        return _react2.default.createElement(
          'div',
          { className: 'cube_bars__list__content' },
          (0, _lodash2.default)(serie).sortBy('c').reverse().filter(function (d) {
            return !_this2.props.filter || RegExp(_this2.props.filter, 'i').test(d.name);
          }).slice(0, this.props.slice || serie.length).map(function (d) {
            var comparingData = null;
            if (_this2.props.comparingTo && _this2.props.comparingTo.serie) {
              comparingData = _this2.props.comparingTo.serie[d.key] ? _this2.props.comparingTo.serie[d.key] : { c: 0 };
            }
            return _react2.default.createElement(_bar_line2.default, {
              key: d.key,
              name: _this2.props.name,
              label: prefix ? d.name.startsWith(prefix) ? d.name.substring(prefix.length) : d.name : d.name,
              total: total,
              comparingTotal: _this2.props.comparingTo ? _this2.props.comparingTo.total : null,
              max: Math.max(max, comparingMax),
              data: d,
              group: _this2.props.group,
              stretched: _this2.props.stretched,
              container: _this2,
              onChange: _this2.props.onChange,
              comparingData: comparingData,
              getColor: _this2.props.getColor,
              selected: _this2.props.selected.indexOf(d.key) >= 0
            });
          }).value()
        );
      }

      return _react2.default.createElement(
        'div',
        { className: 'cube_bars__list__content--empty' },
        'No dimension available'
      );
    }
  }]);

  return BarList;
}(_react2.default.Component);

BarList.propTypes = {
  dimension: _propTypes2.default.object,
  slice: _propTypes2.default.number,
  hideCommonPrefix: _propTypes2.default.bool,
  stretched: _propTypes2.default.bool,
  filter: _propTypes2.default.string,
  getColor: _propTypes2.default.func,
  group: _propTypes2.default.string,
  name: _propTypes2.default.string,
  comparingTo: _propTypes2.default.object,
  lookup: _propTypes2.default.object,
  selected: _propTypes2.default.array
};
BarList.defaultProps = {
  hideCommonPrefix: false,
  stretched: false,
  getColor: (0, _d3Scale.scaleOrdinal)(_d.schemeCategory20c)
};
exports.default = BarList;