'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _map2 = require('lodash/map');

var _map3 = _interopRequireDefault(_map2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _BarGraph = require('../BarGraph');

var _BarGraph2 = _interopRequireDefault(_BarGraph);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// TODO remove lodash


var BarGraphColumn = function (_React$Component) {
  _inherits(BarGraphColumn, _React$Component);

  function BarGraphColumn(props) {
    _classCallCheck(this, BarGraphColumn);

    var _this = _possibleConstructorReturn(this, (BarGraphColumn.__proto__ || Object.getPrototypeOf(BarGraphColumn)).call(this, props));

    _this.onStretch = function (serie) {
      return function () {
        _this.setState({
          stretched: Object.assign({}, _this.state.stretched, _defineProperty({}, _this.props.name + serie, !_this.state.stretched[_this.props.name + serie]))
        });
      };
    };

    _this.onSearch = function (serie) {
      return function (e) {
        var search = e.target.value;
        if (search.length) {
          try {
            new RegExp(search, 'i');
            _this.setState({
              search: Object.assign({}, _this.state.search, _defineProperty({}, serie, search))
            });
          } catch (e) {
            _this.setState({
              search: Object.assign({}, _this.state.search, _defineProperty({}, serie, false))
            });
          }
        } else {
          _this.setState({
            search: Object.assign({}, _this.state.search, _defineProperty({}, serie, undefined))
          });
        }
      };
    };

    _this.state = {
      stretched: [],
      search: []
    };
    return _this;
  }

  _createClass(BarGraphColumn, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      return _react2.default.createElement(
        'div',
        { className: 'cube_graph__column' },
        (0, _map3.default)(this.props.data, function (serie, key) {
          var description = _this2.props.dataDescription ? _this2.props.dataDescription[key] : undefined;

          return _react2.default.createElement(
            'div',
            { key: key, className: 'bar-graph-group__list' },
            _react2.default.createElement(_BarGraph2.default, {
              name: key,
              description: description,
              data: serie,
              comparingTo: _this2.props.comparingTo && _this2.props.comparingTo[key],
              selected: _this2.props.selectedItems && _this2.props.selectedItems[key],
              onChange: _this2.props.onChange,
              slice: _this2.props.slice,
              group: _this2.props.group,
              lookup: _this2.props.lookup,
              getColor: _this2.props.getColor,
              allData: _this2.props.allData
            })
          );
        })
      );
    }
  }]);

  return BarGraphColumn;
}(_react2.default.Component);

exports.default = BarGraphColumn;